---
title: new operator
slug: Web/JavaScript/Reference/Operators/new
tags:
  - JavaScript
  - Language feature
  - Left-hand-side expressions
  - Operator
  - Reference
---
<div>{{jsSidebar("Operators")}}</div>

<p><span class="seoSummary">The <strong><code>new</code> operator</strong> lets developers create an instance of a user-defined object type or of one of the built-in object types that has a constructor function.</span></p>

<div>{{EmbedInteractiveExample("pages/js/expressions-newoperator.html")}}</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">new <var>constructor</var>[([<var>arguments</var>])]</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>constructor</var></code></dt>
 <dd>A class or function that specifies the type of the object instance.</dd>
</dl>

<dl>
 <dt><code><var>arguments</var></code></dt>
 <dd>A list of values that the <code><var>constructor</var></code> will be called with.</dd>
</dl>

<h2 id="Description">Description</h2>

<p>The <strong><code>new</code></strong> keyword does the following things:</p>

<ol>
 <li>Creates a blank, plain JavaScript object;</li>
 <li>Links (sets the constructor of) the newly created object to another object by setting the other object as its parent prototype;</li>
 <li>Passes the newly created object from <em>Step 1</em> as the <code>this</code> context;</li>
 <li>Returns <code>this</code> if the function doesn't return an object.</li>
</ol>

<p>Creating a user-defined object requires two steps:</p>

<ol>
 <li>Define the object type by writing a function.</li>
 <li>Create an instance of the object with <code>new</code>.</li>
</ol>

<p>To define an object type, create a function for the object type that specifies its name and properties. An object can have a property that is itself another object. See the examples below.</p>

<p>When the code <code>new <em>Foo</em>(...)</code> is executed, the following things happen:</p>

<ol>
 <li>A new object is created, inheriting from <code><em>Foo</em>.prototype</code>.</li>
 <li>The constructor function <code><em>Foo</em></code> is called with the specified arguments, and with <code><a href="/en-US/docs/Web/JavaScript/Reference/Operators/this">this</a></code> bound to the newly created object. <code>new <em>Foo</em></code> is equivalent to <code>new <em>Foo</em>()</code>, i.e. if no argument list is specified, <code><em>Foo</em></code> is called without arguments.</li>
 <li>The object (not null, false, 3.1415 or other primitive types) returned by the constructor function becomes the result of the whole <code>new</code> expression. If the constructor function doesn't explicitly return an object, the object created in step 1 is used instead. (Normally constructors don't return a value, but they can choose to do so if they want to override the normal object creation process.)</li>
</ol>

<p>You can always add a property to a previously defined object. For example, the statement <code>car1.color = "black"</code> adds a property <code>color</code> to <code>car1</code>, and assigns it a value of "<code>black</code>". However, this does not affect any other objects. To add the new property to all objects of the same type, you must add the property to the definition of the <code>Car</code> object type.</p>

<p>You can add a shared property to a previously defined object type by using the <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function/prototype">Function.prototype.prototype</a></code> property. This defines a property that is shared by all objects created with that function, rather than by just one instance of the object type. The following code adds a color property with value <code>"original color"</code> to all objects of type <code>Car</code>, and then overwrites that value with the string "<code>black</code>" only in the instance object <code>car1</code>. For more information, see <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function/prototype">prototype</a>.</p>

<pre class="brush: js notranslate">function Car() {}
car1 = new Car();
car2 = new Car();

console.log(car1.color);    // undefined

Car.prototype.color = 'original color';
console.log(car1.color);    // 'original color'

car1.color = 'black';
console.log(car1.color);    // 'black'

console.log(Object.getPrototypeOf(car1).color); // 'original color'
console.log(Object.getPrototypeOf(car2).color); // 'original color'
console.log(car1.color);   // 'black'
console.log(car2.color);   // 'original color'
</pre>

<div class="note">
<p>If you didn't write the <code>new</code> operator, <strong>the Constructor Function would be invoked like any Regular Function,</strong> <em>without creating an Object.</em> In this case, the value of <code>this</code> is also different.</p>
</div>

<h2 id="Examples">Examples</h2>

<h3 id="Object_type_and_object_instance">Object type and object instance</h3>

<p>Suppose you want to create an object type for cars. You want this type of object to be called <code>Car</code>, and you want it to have properties for make, model, and year. To do this, you would write the following function:</p>

<pre class="brush: js notranslate">function Car(make, model, year) {
  this.make = make;
  this.model = model;
  this.year = year;
}
</pre>

<p>Now you can create an object called <code>myCar</code> as follows:</p>

<pre class="brush: js notranslate">var myCar = new Car('Eagle', 'Talon TSi', 1993);
</pre>

<p>This statement creates <code>myCar</code> and assigns it the specified values for its properties. Then the value of <code>myCar.make</code> is the string "Eagle", <code>myCar.year</code> is the integer 1993, and so on.</p>

<p>You can create any number of <code>car</code> objects by calls to <code>new</code>. For example:</p>

<pre class="brush: js notranslate">var kensCar = new Car('Nissan', '300ZX', 1992);
</pre>

<h3 id="Object_property_that_is_itself_another_object">Object property that is itself another object</h3>

<p>Suppose you define an object called <code>Person</code> as follows:</p>

<pre class="brush: js notranslate">function Person(name, age, sex) {
  this.name = name;
  this.age = age;
  this.sex = sex;
}
</pre>

<p>And then instantiate two new <code>Person</code> objects as follows:</p>

<pre class="brush: js notranslate">var rand = new Person('Rand McNally', 33, 'M');
var ken = new Person('Ken Jones', 39, 'M');
</pre>

<p>Then you can rewrite the definition of <code>Car</code> to include an <code>owner</code> property that takes a <code>Person</code> object, as follows:</p>

<pre class="brush: js notranslate">function Car(make, model, year, owner) {
  this.make = make;
  this.model = model;
  this.year = year;
  this.owner = owner;
}
</pre>

<p>To instantiate the new objects, you then use the following:</p>

<pre class="brush: js notranslate">var car1 = new Car('Eagle', 'Talon TSi', 1993, rand);
var car2 = new Car('Nissan', '300ZX', 1992, ken);
</pre>

<p>Instead of passing a literal string or integer value when creating the new objects, the above statements pass the objects <code>rand</code> and <code>ken</code> as the parameters for the owners. To find out the name of the owner of <code>car2</code>, you can access the following property:</p>

<pre class="brush: js notranslate">car2.owner.name
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-new-operator', 'The new Operator')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.operators.new")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Function")}}</li>
 <li>{{jsxref("Reflect.construct()")}}</li>
 <li>{{jsxref("Object.prototype")}}</li>
</ul>
